﻿using Models.model;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace AQuarantineAdventure
{
    /// <summary>
    /// Lógica de interacción para CharSelect.xaml
    /// </summary>
    public partial class CharSelect : Window
    {
        Start_Window sw;
        Rolechar character;
        Map_Window mapw;
        Model myModel;

        public CharSelect()
        {
            InitializeComponent();
            myModel = Model.getInstance();
            initNamesChar();
        }

        //-----------------------------------CHARACTERS------------------------------

        /// <summary>
        /// petition for the character
        /// </summary>
        /// <param name="character">the character for the request</param>
        private async void getPetitionRolechar(Rolechar character)
        {
            try
            {
                string URL_findChar = Properties.Settings.Default.URL_findChar + character.IdChar;
                //Console.WriteLine(URL_findChar);           
                ResponseResult uResult = await myModel.getPetition(URL_findChar);
                if (uResult.ResultCode == 1)
                {
                    character = myModel.convertDataToRolechar(uResult.Data);
                    myModel.setRolechar(character);
                   // Console.WriteLine(character.ToString()); 
                }
            }
            catch (WebException ex)
            {
                Console.WriteLine("error " + ex.Message);
                // merror conection message
            }
            catch (JsonReaderException jre)
            {
                Console.WriteLine("error " + jre.Message);
            }         
        }

        //Charselect La Jenny
        private void btn_c1_Click(object sender, RoutedEventArgs e)
        {
            initNamesChar();
            character = new Rolechar();
            character.IdChar = 1;         
            getPetitionRolechar(character); // peticion get de rolechar 
            btn_c1.Content = "Eliges La Jeny";
        }

        //charselect Cristian
        private void btn_c2_Click(object sender, RoutedEventArgs e)
        {
            initNamesChar();
            character = new Rolechar();
            character.IdChar = 2;            
            getPetitionRolechar(character);// petition get of rolechar 
            btn_c2.Content = "Eliges Cristian" ;
        }

        //charselect Gertrudis
        private void btn_c3_Click(object sender, RoutedEventArgs e)
        {
            initNamesChar();
            character = new Rolechar();
            character.IdChar = 3;            
            getPetitionRolechar(character);// peticion get of rolechar
            btn_c3.Content = "Eliges Gertrudis";
        }

        //When cliked, sets the parameters IdChar and  gname and begins de game
        private void btn_initGame_Click(object sender, RoutedEventArgs e)
        {
            Game partida = new Game();
            partida.Gname = tb_gname.Text;
            myModel.setGame(partida);
            mapw = new Map_Window();           
            mapw.Visibility = Visibility.Visible;
            this.Visibility = Visibility.Collapsed;         
        }

        //initialize the characters name
        public void initNamesChar()
        {
            btn_c1.Content = "La Jeny";
            btn_c2.Content = "Cristian";
            btn_c3.Content = "Gertrudis";
        }
       
        // go back to the start_window
        private void btn_back_Click(object sender, RoutedEventArgs e)
        {
            sw = new Start_Window();
            sw.Visibility= Visibility.Visible;
            this.Visibility= Visibility.Collapsed;            
        }

        // Return back to start window
        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Seguro que quieres cancelar la selección de personaje?", "Salir", MessageBoxButton.YesNo, MessageBoxImage.Information);
            if (result == MessageBoxResult.Yes)
            {
                sw = new Start_Window();
                //sw.Show();
                sw.Visibility = Visibility.Visible;
                // sw.Show();
                this.Visibility = Visibility.Collapsed;
                e.Cancel = false;
            }
            else
            {
                e.Cancel = true;
            }
        }

        // methods for change content of button back (btn_cancel)
        private void btn_cancel_MouseEnter(object sender, MouseEventArgs e)
        {
            btn_cancel.Content = "Ir atrás";
        }
        private void btn_cancel_MouseLeave(object sender, MouseEventArgs e)
        {
            btn_cancel.Content = "↩";
        }
       
    }
}
