﻿using Models.model;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace AQuarantineAdventure
{
    /// <summary>
    /// Lógica de interacción para Map_Window.xaml
    /// </summary>
    public partial class Map_Window : Window
    {
        Event_Window ew;
        Consequence_Window consw;
        Model myModel;
        List<Locs> locs;
        Rolechar rolc;

        public Map_Window()
        {
            InitializeComponent();
            myModel = Model.getInstance();
            initTitle();
            initLocalizations();
            getPetitionLocs();
        }

        /// <summary>
        ///  Button for the first location of the game
        ///  does the new game petition and initialize parameters like location and character
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn_start_Click(object sender, RoutedEventArgs e)
        {
            rolc = new Rolechar();
            rolc = myModel.getRolechar();
            if (rolc.IdChar == 1)
            {
                av_lajeny.Visibility = Visibility.Visible;
            }else if(rolc.IdChar == 2)
            {
                av_cristian.Visibility = Visibility.Visible;
            }
            else if (rolc.IdChar == 3)
            {
                av_gertrudis.Visibility = Visibility.Visible;
            }

            string loc_code;
            locs = myModel.getLocs();
            foreach(Locs loc in locs){
                if(loc.NameLoc == "start")
                {
                    loc_code = loc.IdLoc;
                    //Console.WriteLine(loc_code.ToString());
                    myModel.setCurrentLoc(loc);                  
                    generateNewGame(loc_code);//peticion NEW GAME
                }
            }         
            btn_start.Visibility = Visibility.Hidden;
            ew = new Event_Window();            
            ew.Visibility = Visibility.Visible;         
            btn_store.Visibility = Visibility.Visible; // next loc visible, moving character                    
        }

        // Button for the second location of the game
        private void btn_store_Click(object sender, RoutedEventArgs e)
        {
            locs = myModel.getLocs();          
            string loc_code;
            foreach (Locs loc in locs)
            {
                if (loc.NameLoc == "store")
                {
                    loc_code = loc.IdLoc;
                    //Console.WriteLine(loc_code.ToString());
                    myModel.setCurrentLoc(loc);
                }
            }
            btn_store.Visibility = Visibility.Hidden;          
            ew = new Event_Window();
            ew.Visibility = Visibility.Visible;
            btn_park.Visibility = Visibility.Visible;        
        }

        // Button for the third location of the game
        private void btn_park_Click(object sender, RoutedEventArgs e)
        {
            locs = myModel.getLocs();           
            string loc_code;
            foreach (Locs loc in locs)
            {
                if (loc.NameLoc == "park")
                {
                    loc_code = loc.IdLoc;
                    //Console.WriteLine(loc_code.ToString());
                    myModel.setCurrentLoc(loc);
                }
            }
            btn_park.Visibility = Visibility.Hidden;
            ew = new Event_Window();
            ew.Visibility = Visibility.Visible;
            btn_bridge.Visibility = Visibility.Visible;            
        }

        // Button for the fourth location of the game
        private void btn_bridge_Click(object sender, RoutedEventArgs e)
        {
            locs = myModel.getLocs();          
            string loc_code;
            foreach (Locs loc in locs)
            {
                if (loc.NameLoc == "bridge")
                {
                    loc_code = loc.IdLoc;
                    //Console.WriteLine(loc_code.ToString());
                    myModel.setCurrentLoc(loc);
                }
            }
            btn_bridge.Visibility = Visibility.Hidden;
            ew = new Event_Window();
            ew.Visibility = Visibility.Visible;                    
            btn_forest.Visibility = Visibility.Visible;           
        }

        // Button for the fifth location of the game
        private void btn_forest_Click(object sender, RoutedEventArgs e)
        {
            locs = myModel.getLocs();         
            string loc_code;
            foreach (Locs loc in locs)
            {
                if (loc.NameLoc == "forest")
                {
                    loc_code = loc.IdLoc;
                    //Console.WriteLine(loc_code.ToString());
                    myModel.setCurrentLoc(loc);
                }
            }
            btn_forest.Visibility = Visibility.Hidden;
            ew = new Event_Window();
            ew.Visibility = Visibility.Visible;
            btn_square.Visibility = Visibility.Visible;            
        }

        // Button for the sixth location of the game
        private void btn_square_Click(object sender, RoutedEventArgs e)
        {
            locs = myModel.getLocs();
            ew = new Event_Window();
            string loc_code;
            foreach (Locs loc in locs)
            {
                if (loc.NameLoc == "square")
                {
                    loc_code = loc.IdLoc;
                   //Console.WriteLine(loc_code.ToString());
                    myModel.setCurrentLoc(loc);
                }
            }
            btn_square.Visibility = Visibility.Hidden;          
            ew = new Event_Window();
            ew.Visibility = Visibility.Visible;        
            btn_end.Visibility = Visibility.Visible;          
        }

        // Button for the seventh (and last) location of the game
        private void btn_end_Click(object sender, RoutedEventArgs e)
        {
            locs = myModel.getLocs();          
            string loc_code;
            foreach (Locs loc in locs)
            {
                if (loc.NameLoc == "end")
                {
                    loc_code = loc.IdLoc;                 
                    myModel.setCurrentLoc(loc);
                }
            }          
            btn_end.Visibility = Visibility.Hidden;
            consw = new Consequence_Window();          
            consw.Visibility = Visibility.Visible;
            this.Hide();
        }

        /// <summary>
        /// Initialize the visibility of button locations
        /// </summary>
        private void initLocalizations()
        {
            btn_start.Visibility = Visibility.Visible;
            btn_store.Visibility = Visibility.Hidden;
            btn_park.Visibility = Visibility.Hidden;
            btn_bridge.Visibility = Visibility.Hidden;
            btn_forest.Visibility = Visibility.Hidden;
            btn_square.Visibility = Visibility.Hidden;
            btn_end.Visibility = Visibility.Hidden;
        }

        // GET petition for list of localizations (locs)
        private async void getPetitionLocs()
        {
            try
            {
                string URL_findlocs = Properties.Settings.Default.URL_findLocs;
                //Console.WriteLine(URL_findlocs); // solo test          
                ResponseResult uResult = await myModel.getPetition(URL_findlocs);
                if (uResult.ResultCode == 1)
                {
                    locs = myModel.convertDataToLocs(uResult.Data);
                    myModel.setLocs(locs);
                   /* // testing solo
                    foreach (Locs loc in locs)
                    {
                        Console.WriteLine(loc.ToString());
                    }            */       
                }
            }
            catch (WebException ex)
            {
                Console.WriteLine("error " + ex.Message);
                // error conection message
            }
            catch (JsonReaderException jre)
            {
                Console.WriteLine("error " + jre.Message);
            }
        }

        // Petition for generate a new game (Post)
        private async void generateNewGame(string locCode )
        {
            Rolechar rolechar = myModel.getRolechar();
            User player = myModel.getCurrentUser();
            Game gtemp = myModel.getGame();
            Game partida = new Game(locCode,player.IdUser,gtemp.Gname,rolechar.IdChar);           
            string URL_newgame = Properties.Settings.Default.URL_addGame;
            //Console.WriteLine(URL_newgame);
            try
            {
                ResponseResult result = await myModel.deserializeResultGame(URL_newgame, partida);// transforms game  into a json format
                if (result.ResultCode == 0)
                {
                    MessageBox.Show("Error ! Algo ocurrió durante el proceso...", "Error!", MessageBoxButton.OK, MessageBoxImage.Error);
                    this.Close();
                }
                else if (result.ResultCode == -1)
                {
                    MessageBox.Show("El nombre es demasiado largo!!", "Error!", MessageBoxButton.OK, MessageBoxImage.Error);
                    this.Hide();
                    Start_Window sw = new Start_Window();
                    sw.Show();
                }
                else if (result.ResultCode == 1)
                {
                   // MessageBox.Show("Partida generada con éxito", "Bien!", MessageBoxButton.OK, MessageBoxImage.Information);
                    myModel.setGame(partida);                   
                }
            }
            catch (WebException ex)
            {
                Console.WriteLine("error " + ex.Message);
                // mensaje de error de conexion)
            }
            catch (JsonReaderException jre)
            {
                Console.WriteLine("error " + jre.Message);
            }
        }

        //initialize title
        private void initTitle()
        {
            Game game = new Game();
            game = myModel.getGame();
            this.Title = "A Quarantine Adventure: " + game.Gname;
        }      
    }
}
