﻿
using Models.model;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace AQuarantineAdventure
{
    /// <summary>
    /// Lógica de interacción para Register_Window.xaml
    /// </summary>
    public partial class Register_Window : Window
    {
        Model myModel;
        MainWindow mw = new MainWindow();
        public Register_Window()
        {
            InitializeComponent();
        }

        // The newUser accepts sending the credentials
        private async void btn_accept_Click(object sender, RoutedEventArgs e)
        {           
            User newUser;
            myModel = Model.getInstance();           
            string newIduser = tb_user.Text;
            string newPass = tb_pass.Password;           
            if (newIduser == "" || newPass == "")
            {
                MessageBox.Show("Faltan campos por rellenar!", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            
            else if (newIduser != "" && newPass != "")
            {
                newUser = new User(newIduser, newPass);
                string URL_register = Properties.Settings.Default.URL_register;
                Console.WriteLine(URL_register); 
                try
                {
                    ResponseResult result = await myModel.deserializeResult(URL_register, newUser);// transforms User  into a json format
                    if (result.ResultCode == 0)
                    {
                        MessageBox.Show("Uoops! Ocurrió un error durante el proceso", "Error!", MessageBoxButton.OK, MessageBoxImage.Error);
                        mw.CleanFields();
                    }
                    else if (result.ResultCode == -1)
                    {
                        MessageBox.Show("Vaya! Parece que ese usuario ya existe! tendrás que pensar en otro nombre.", "Error!", MessageBoxButton.OK, MessageBoxImage.Error);                     
                        mw.CleanFields();
                    }
                    else if(result.ResultCode == 1)
                    {
                        MessageBox.Show("Felicidades, tu registro se ha completado correctamente. Disfruta del juego!", "Registro Completado!", MessageBoxButton.OK, MessageBoxImage.Information);
                        mw.CleanFields();
                        mw.Show();
                        this.Close();
                    }
                }
                catch (WebException ex)
                {
                    Console.WriteLine("error " + ex.Message);
                    // mensaje de error de conexion)
                }
                catch (JsonReaderException jre)
                {
                    Console.WriteLine("error " + jre.Message);
                }
            }
        }

        // User cancel the register and go back to main window
        private void btn_cancel_Click(object sender, RoutedEventArgs e)
        {
            mw.Show();
            this.Close();
        }
    }
}

