﻿using Models;
using Models.model;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace Models.persistence
{
    public class MysqlDAO
    {
        private static MysqlDAO instanceUser;

        public static MysqlDAO getInstance()
        {
            if(instanceUser == null)
            {
                instanceUser = new MysqlDAO();
            }
            return instanceUser;
        }

        //--------------------------GET (COMMON) ---------------

        /// <summary>
        ///  GET-- Gets a response of the httpRequest and send response to the MODEL.
        /// </summary>
        /// <param name="url">The URL for the petition</param>
        /// <returns>A response String</returns>
        public async Task<string> GetHttp(string url)
        {
            WebRequest oRequest = WebRequest.Create(url);
            WebResponse oResponse = oRequest.GetResponse();
            StreamReader sr = new StreamReader(oResponse.GetResponseStream());
            return await sr.ReadToEndAsync();
        }

        //---------------------------------------USER --------------------------------------------
        /// <summary>
        /// POST-- send an user in JSON format and get response from the server
        /// </summary>
        /// <param name="url"></param>
        /// <returns>A response String</returns>
        public async Task<string> postHttpUser(string url,User user) 
        {
            string response = "";
            WebRequest wr = WebRequest.Create(url);
            wr.Method = "POST";
            wr.ContentType = "application/json;charset=UTF-8";
            using (var sw = new StreamWriter(wr.GetRequestStream()))
            {
                string json = "{\"idUser\": \"" + user.IdUser + "\", " + "\"password\": \"" + user.Password + "\"}";
                sw.Write(json);
                sw.Flush();
                sw.Close();
            }
            //lectura
            WebResponse wresponse = wr.GetResponse();
            using (var sr = new StreamReader(wresponse.GetResponseStream()))
            {
                response = await sr.ReadToEndAsync();
            }
            return response;
        }

        /// <summary>
        /// POST-- send an user in JSON format and get response from the server for actualize current user
        /// </summary>
        /// <param name="url"></param>
        /// <returns>A response String</returns>
        public async Task<string> postHttpActualizeUser(string url, User user)
        {
            string response = "";
            WebRequest wr = WebRequest.Create(url);
            wr.Method = "POST";
            wr.ContentType = "application/json;charset=UTF-8";
            using (var sw = new StreamWriter(wr.GetRequestStream()))
            {
                string json = "{\"idUser\": \"" + user.IdUser + "\", " + "\"password\": \"" + user.Password +"\", " + "\"coins\": \"" + user.Coins + "\"}";
                sw.Write(json);
                sw.Flush();
                sw.Close();
            }
            //lectura
            WebResponse wresponse = wr.GetResponse();
            using (var sr = new StreamReader(wresponse.GetResponseStream()))
            {
                response = await sr.ReadToEndAsync();
            }
            return response;
        }

        //---------------------------------------MAX_SCORE ---------------------------------------

        /// <summary>
        /// POST-- send score in JSON format and get response from the server
        /// </summary>
        /// <param name="url"></param>
        /// <returns>A response String</returns>
        public async Task<string> postHttpScore(string url, Max_score score)
        {
            string response = "";
            WebRequest wr = WebRequest.Create(url);
            wr.Method = "POST";
            wr.ContentType = "application/json;charset=UTF-8";
            using (var sw = new StreamWriter(wr.GetRequestStream()))
            {
                string json = "{\"user_code\": \"" + score.User_code + "\", " + "\"max_happiness\": \"" + score.Max_happiness + "\"}";
                sw.Write(json);
                sw.Flush();
                sw.Close();
            }
            //lectura
            WebResponse wresponse = wr.GetResponse();
            using (var sr = new StreamReader(wresponse.GetResponseStream()))
            {
                response = await sr.ReadToEndAsync();
            }
            return response;
        }

        // ----------------------------GAME ------------------------------------
       
        /// <summary>
        /// POST-- send a game in JSON format and get response from the server
        /// </summary>
        /// <param name="url"></param>
        /// <returns>A response String</returns>
        public async Task<string> postHttpGame(string url, Game newgame)
        {
            string response = "";
            WebRequest wr = WebRequest.Create(url);
            wr.Method = "POST";
            wr.ContentType = "application/json;charset=UTF-8";
            using (var sw = new StreamWriter(wr.GetRequestStream()))
            {
                string json = "{\"actual_loc\": \"" + newgame.Actual_loc + "\", " + "\"u_code\": \"" + newgame.U_code + "\", " + "\"gname\": \"" + newgame.Gname + "\", " + "\"char_code\": \"" + newgame.Char_code + "\"}";
                sw.Write(json);
                sw.Flush();
                sw.Close();
            }
            //lectura
            WebResponse wresponse = wr.GetResponse();
            using (var sr = new StreamReader(wresponse.GetResponseStream()))
            {
                response = await sr.ReadToEndAsync();
            }
            return response;
        }
    }
}
